.686p
.model  flat, stdcall
.nolist
include windows.inc

inv equ invoke

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
;uselib shell32
;uselib comdlg32
uselib gdi32
;uselib masm32
;uselib debug

.list

.data?
hWin  dd ?
buff  db 100 dup (?)
ps  PAINTSTRUCT <>
hdc HDC ?
mDC HDC ?

hBmp1   dd ?
hBmp2   dd ?
hBmp3   dd ?
hBmp4   dd ?
btmap   BITMAP <>
strtx   dd ?
strty   dd ?
.data
file1 db 'Bitmap_1.bmp',0
file2 db 'Bitmap_2.bmp',0
file3 db 'Bitmap_3.bmp',0
file4 db 'Bitmap_4.bmp',0
.code
Program:
    inv InitCommonControls
    inv GetModuleHandle,0
    inv DialogBoxParam,eax,101,0,DlgProc, 0
    inv ExitProcess, eax

Loadbmp proc indx,filename
    inv LoadImage,0,filename,IMAGE_BITMAP,0,0,LR_LOADFROMFILE
    mov ecx,indx
    mov hBmp1[ecx*4-4],eax
	ret
Loadbmp endp
Showbmp proc indx
    mov eax,indx
    inv SelectObject,mDC,hBmp1[eax*4-4]
    inv BitBlt,hdc,strtx,strty,btmap.bmWidth, btmap.bmHeight ,mDC,0,0,SRCCOPY
    mov eax,btmap.bmWidth
    ;add strtx,eax
    add strtx,20
    add strty,20
	ret
Showbmp endp    
DlgProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if uMsg == WM_COMMAND
        ;.if    wParam == buttonid
        ;.endif
    .elseif uMsg== WM_INITDIALOG
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
        inv Loadbmp,1,addr file1
        inv Loadbmp,2,addr file2
        inv Loadbmp,3,addr file3
        inv Loadbmp,4,addr file4
    .elseif uMsg==WM_PAINT
        inv BeginPaint,hWnd,ADDR ps
        mov hdc,eax
        inv CreateCompatibleDC,eax
        mov mDC,eax

        mov strtx,0
        mov strty,0
        inv GetObject,hBmp1,sizeof btmap,addr btmap
        
        inv Showbmp,1
        inv Showbmp,2
        inv Showbmp,3
        inv Showbmp,4

        inv DeleteDC,mDC
        inv EndPaint,hWnd,ADDR ps
    .elseif uMsg == WM_CLOSE
        inv DeleteObject,hBmp1
        inv DeleteObject,hBmp2
        inv DeleteObject,hBmp3
        inv DeleteObject,hBmp4
        inv EndDialog,hWin,0
    .endif

    xor eax,eax
    ret
DlgProc endp

end Program